summaryrefslogtreecommitdiff
path: root/qa/755
diff options
context:
space:
mode:
authorIgor Pashev <pashev.igor@gmail.com>2014-10-26 12:33:50 +0400
committerIgor Pashev <pashev.igor@gmail.com>2014-10-26 12:33:50 +0400
commit47e6e7c84f008a53061e661f31ae96629bc694ef (patch)
tree648a07f3b5b9d67ce19b0fd72e8caa1175c98f1a /qa/755
downloadpcp-debian.tar.gz
Debian 3.9.10debian/3.9.10debian
Diffstat (limited to 'qa/755')
-rwxr-xr-xqa/75575
1 files changed, 75 insertions, 0 deletions
diff --git a/qa/755 b/qa/755
new file mode 100755
index 0000000..1e5ab30
--- /dev/null
+++ b/qa/755
@@ -0,0 +1,75 @@
+#!/bin/sh
+# PCP QA Test No. 755
+# Exercise the Apache PMDA Install/Remove, as well as the
+# mechanism by which a PMDA can be installed with no pmcd
+# process running.
+#
+# Copyright (c) 2014 Red Hat.
+#
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+# get standard environment, filters and checks
+. ./common.product
+. ./common.filter
+. ./common.check
+
+status=1 # failure is the default!
+$sudo rm -rf $tmp.* $seq.full
+
+_filter_apache()
+{
+ # cull message resulting from no running httpd
+ grep -v 'Information not currently available'
+}
+
+pmdaapache_remove()
+{
+ echo
+ echo "=== remove apache agent ==="
+ $sudo ./Remove >$tmp.out 2>&1
+ _filter_pmda_remove <$tmp.out
+}
+
+pmdaapache_install()
+{
+ # start from known starting points
+ cd $PCP_PMDAS_DIR/apache
+ $sudo ./Remove >/dev/null 2>&1
+ $sudo $PCP_RC_DIR/pmcd stop
+
+ echo
+ echo "=== apache agent installation ==="
+ $sudo ./Install </dev/null >$tmp.out 2>&1
+ # Check apache metrics have appeared ... X metrics and Y values
+ _filter_pmda_install <$tmp.out \
+ | sed \
+ -e '/^Waiting for pmcd/s/\.\.\.[. ]*$/DOTS/' \
+ -e 's/[0-9][0-9]* warnings, //' \
+ | $PCP_AWK_PROG '
+/Check apache metrics have appeared/ { if ($7 >= 20 && $7 <= 80) $7 = "X"
+ if ($10 >= 0 && $10 <= 80) $10 = "Y"
+ }
+ { print }'
+}
+
+_prepare_pmda apache
+trap "_cleanup_pmda apache; exit \$status" 0 1 2 3 15
+
+# real QA test starts here
+pmdaapache_install
+
+# pmcd should have been started by the Install process - check
+if pminfo -v apache > $tmp.info 2> $tmp.err
+then
+ :
+else
+ echo "... failed! ... here is the Install log ..."
+ cat $tmp.out
+fi
+cat $tmp.info $tmp.err | _filter_apache
+
+pmdaapache_remove
+status=0
+exit